
$[ matching-logic-aux.mm $]
$[ matching-logic-prelude-lemmas.mm $]
$v _X999 $. 
 _X999-is-set-var $f #SetVariable _X999 $.


$c a c b $.
a-is-symbol $a #Symbol a $.
c-is-symbol $a #Symbol c $.
b-is-symbol $a #Symbol b $.


test $p |- ( \imp ( \app ( \app ( \imp ( \imp a \bot ) b ) c ) c ) ( \imp ( \imp ( \app ( \app a c ) c ) \bot ) ( \app ( \app b c ) c ) ) ) $= 
              a-is-symbol
            symbol-is-pattern 
              c-is-symbol
            symbol-is-pattern
          app-is-pattern 
          bot-is-pattern
        imp-is-pattern 
            b-is-symbol
          symbol-is-pattern 
            c-is-symbol
          symbol-is-pattern
        app-is-pattern
      imp-is-pattern 
        c-is-symbol
      symbol-is-pattern
    app-is-pattern 
              a-is-symbol
            symbol-is-pattern 
              c-is-symbol
            symbol-is-pattern
          app-is-pattern 
            c-is-symbol
          symbol-is-pattern
        app-is-pattern 
        bot-is-pattern
      imp-is-pattern 
            b-is-symbol
          symbol-is-pattern 
            c-is-symbol
          symbol-is-pattern
        app-is-pattern 
          c-is-symbol
        symbol-is-pattern
      app-is-pattern
    imp-is-pattern
  imp-is-pattern 
              a-is-symbol
            symbol-is-pattern 
            bot-is-pattern
          imp-is-pattern 
            b-is-symbol
          symbol-is-pattern
        imp-is-pattern 
          c-is-symbol
        symbol-is-pattern
      app-is-pattern 
        c-is-symbol
      symbol-is-pattern
    app-is-pattern 
              a-is-symbol
            symbol-is-pattern 
              c-is-symbol
            symbol-is-pattern
          app-is-pattern 
            c-is-symbol
          symbol-is-pattern
        app-is-pattern 
        bot-is-pattern
      imp-is-pattern 
            b-is-symbol
          symbol-is-pattern 
            c-is-symbol
          symbol-is-pattern
        app-is-pattern 
          c-is-symbol
        symbol-is-pattern
      app-is-pattern
    imp-is-pattern
  imp-is-pattern 
                a-is-symbol
              symbol-is-pattern 
              bot-is-pattern
            imp-is-pattern 
              b-is-symbol
            symbol-is-pattern
          imp-is-pattern 
            c-is-symbol
          symbol-is-pattern
        app-is-pattern 
          c-is-symbol
        symbol-is-pattern
      app-is-pattern 
                a-is-symbol
              symbol-is-pattern 
                c-is-symbol
              symbol-is-pattern
            app-is-pattern 
            bot-is-pattern
          imp-is-pattern 
              b-is-symbol
            symbol-is-pattern 
              c-is-symbol
            symbol-is-pattern
          app-is-pattern
        imp-is-pattern 
          c-is-symbol
        symbol-is-pattern
      app-is-pattern
    imp-is-pattern 
                  a-is-symbol
                symbol-is-pattern 
                  c-is-symbol
                symbol-is-pattern
              app-is-pattern 
              bot-is-pattern
            imp-is-pattern 
                b-is-symbol
              symbol-is-pattern 
                c-is-symbol
              symbol-is-pattern
            app-is-pattern
          imp-is-pattern 
            c-is-symbol
          symbol-is-pattern
        app-is-pattern 
                  a-is-symbol
                symbol-is-pattern 
                  c-is-symbol
                symbol-is-pattern
              app-is-pattern 
                c-is-symbol
              symbol-is-pattern
            app-is-pattern 
            bot-is-pattern
          imp-is-pattern 
                b-is-symbol
              symbol-is-pattern 
                c-is-symbol
              symbol-is-pattern
            app-is-pattern 
              c-is-symbol
            symbol-is-pattern
          app-is-pattern
        imp-is-pattern
      imp-is-pattern 
                  a-is-symbol
                symbol-is-pattern 
                bot-is-pattern
              imp-is-pattern 
                b-is-symbol
              symbol-is-pattern
            imp-is-pattern 
              c-is-symbol
            symbol-is-pattern
          app-is-pattern 
            c-is-symbol
          symbol-is-pattern
        app-is-pattern 
                  a-is-symbol
                symbol-is-pattern 
                  c-is-symbol
                symbol-is-pattern
              app-is-pattern 
                c-is-symbol
              symbol-is-pattern
            app-is-pattern 
            bot-is-pattern
          imp-is-pattern 
                b-is-symbol
              symbol-is-pattern 
                c-is-symbol
              symbol-is-pattern
            app-is-pattern 
              c-is-symbol
            symbol-is-pattern
          app-is-pattern
        imp-is-pattern
      imp-is-pattern
    imp-is-pattern 
                a-is-symbol
              symbol-is-pattern 
              bot-is-pattern
            imp-is-pattern 
              b-is-symbol
            symbol-is-pattern
          imp-is-pattern 
            c-is-symbol
          symbol-is-pattern
        app-is-pattern 
          c-is-symbol
        symbol-is-pattern
      app-is-pattern 
                a-is-symbol
              symbol-is-pattern 
                c-is-symbol
              symbol-is-pattern
            app-is-pattern 
            bot-is-pattern
          imp-is-pattern 
              b-is-symbol
            symbol-is-pattern 
              c-is-symbol
            symbol-is-pattern
          app-is-pattern
        imp-is-pattern 
          c-is-symbol
        symbol-is-pattern
      app-is-pattern 
                a-is-symbol
              symbol-is-pattern 
                c-is-symbol
              symbol-is-pattern
            app-is-pattern 
              c-is-symbol
            symbol-is-pattern
          app-is-pattern 
          bot-is-pattern
        imp-is-pattern 
              b-is-symbol
            symbol-is-pattern 
              c-is-symbol
            symbol-is-pattern
          app-is-pattern 
            c-is-symbol
          symbol-is-pattern
        app-is-pattern
      imp-is-pattern
    imp-transitivity 
            _X999-is-set-var
          set-var-is-var
        var-is-pattern 
          c-is-symbol
        symbol-is-pattern
      app-is-pattern 
                a-is-symbol
              symbol-is-pattern 
              bot-is-pattern
            imp-is-pattern 
              b-is-symbol
            symbol-is-pattern
          imp-is-pattern 
            c-is-symbol
          symbol-is-pattern
        app-is-pattern 
          c-is-symbol
        symbol-is-pattern
      app-is-pattern 
                a-is-symbol
              symbol-is-pattern 
                c-is-symbol
              symbol-is-pattern
            app-is-pattern 
            bot-is-pattern
          imp-is-pattern 
              b-is-symbol
            symbol-is-pattern 
              c-is-symbol
            symbol-is-pattern
          app-is-pattern
        imp-is-pattern 
          c-is-symbol
        symbol-is-pattern
      app-is-pattern 
              a-is-symbol
            symbol-is-pattern 
            bot-is-pattern
          imp-is-pattern 
            b-is-symbol
          symbol-is-pattern
        imp-is-pattern 
          c-is-symbol
        symbol-is-pattern
      app-is-pattern 
              a-is-symbol
            symbol-is-pattern 
              c-is-symbol
            symbol-is-pattern
          app-is-pattern 
          bot-is-pattern
        imp-is-pattern 
            b-is-symbol
          symbol-is-pattern 
            c-is-symbol
          symbol-is-pattern
        app-is-pattern
      imp-is-pattern 
        _X999-is-set-var
      set-var-is-var $( xX  $) 
            _X999-is-set-var
          set-var-is-var
        var-is-pattern 
          c-is-symbol
        symbol-is-pattern 
          _X999-is-set-var
        set-var-is-var 
            _X999-is-set-var
          set-var-is-var
        application-context-var
      application-context-app-left 
                a-is-symbol
              symbol-is-pattern 
              bot-is-pattern
            imp-is-pattern 
              b-is-symbol
            symbol-is-pattern
          imp-is-pattern 
            c-is-symbol
          symbol-is-pattern
        app-is-pattern 
                a-is-symbol
              symbol-is-pattern 
              bot-is-pattern
            imp-is-pattern 
              b-is-symbol
            symbol-is-pattern
          imp-is-pattern 
            c-is-symbol
          symbol-is-pattern
        app-is-pattern 
          c-is-symbol
        symbol-is-pattern 
            _X999-is-set-var
          set-var-is-var
        var-is-pattern 
          c-is-symbol
        symbol-is-pattern 
          _X999-is-set-var
        set-var-is-var 
                  a-is-symbol
                symbol-is-pattern 
                bot-is-pattern
              imp-is-pattern 
                b-is-symbol
              symbol-is-pattern
            imp-is-pattern 
              c-is-symbol
            symbol-is-pattern
          app-is-pattern 
            _X999-is-set-var
          set-var-is-var
        substitution-var-same $( substitution-app.0 $) 
            c-is-symbol
          symbol-is-pattern 
                  a-is-symbol
                symbol-is-pattern 
                bot-is-pattern
              imp-is-pattern 
                b-is-symbol
              symbol-is-pattern
            imp-is-pattern 
              c-is-symbol
            symbol-is-pattern
          app-is-pattern 
            _X999-is-set-var
          set-var-is-var 
              _X999-is-set-var
            set-var-is-var 
            c-is-symbol
          fresh-in-symbol $( substitution-fresh.0 $)
        substitution-fresh $( substitution-app.1 $)
      substitution-app $( proof-rule-frame.1 $) 
                a-is-symbol
              symbol-is-pattern 
                c-is-symbol
              symbol-is-pattern
            app-is-pattern 
            bot-is-pattern
          imp-is-pattern 
              b-is-symbol
            symbol-is-pattern 
              c-is-symbol
            symbol-is-pattern
          app-is-pattern
        imp-is-pattern 
                a-is-symbol
              symbol-is-pattern 
                c-is-symbol
              symbol-is-pattern
            app-is-pattern 
            bot-is-pattern
          imp-is-pattern 
              b-is-symbol
            symbol-is-pattern 
              c-is-symbol
            symbol-is-pattern
          app-is-pattern
        imp-is-pattern 
          c-is-symbol
        symbol-is-pattern 
            _X999-is-set-var
          set-var-is-var
        var-is-pattern 
          c-is-symbol
        symbol-is-pattern 
          _X999-is-set-var
        set-var-is-var 
                  a-is-symbol
                symbol-is-pattern 
                  c-is-symbol
                symbol-is-pattern
              app-is-pattern 
              bot-is-pattern
            imp-is-pattern 
                b-is-symbol
              symbol-is-pattern 
                c-is-symbol
              symbol-is-pattern
            app-is-pattern
          imp-is-pattern 
            _X999-is-set-var
          set-var-is-var
        substitution-var-same $( substitution-app.0 $) 
            c-is-symbol
          symbol-is-pattern 
                  a-is-symbol
                symbol-is-pattern 
                  c-is-symbol
                symbol-is-pattern
              app-is-pattern 
              bot-is-pattern
            imp-is-pattern 
                b-is-symbol
              symbol-is-pattern 
                c-is-symbol
              symbol-is-pattern
            app-is-pattern
          imp-is-pattern 
            _X999-is-set-var
          set-var-is-var 
              _X999-is-set-var
            set-var-is-var 
            c-is-symbol
          fresh-in-symbol $( substitution-fresh.0 $)
        substitution-fresh $( substitution-app.1 $)
      substitution-app $( proof-rule-frame.2 $) 
                  a-is-symbol
                symbol-is-pattern 
                bot-is-pattern
              imp-is-pattern 
                b-is-symbol
              symbol-is-pattern
            imp-is-pattern 
              c-is-symbol
            symbol-is-pattern
          app-is-pattern 
                  a-is-symbol
                symbol-is-pattern 
                  c-is-symbol
                symbol-is-pattern
              app-is-pattern 
              bot-is-pattern
            imp-is-pattern 
                b-is-symbol
              symbol-is-pattern 
                c-is-symbol
              symbol-is-pattern
            app-is-pattern
          imp-is-pattern
        imp-is-pattern 
                  a-is-symbol
                symbol-is-pattern 
                bot-is-pattern
              imp-is-pattern 
                b-is-symbol
              symbol-is-pattern
            imp-is-pattern 
              c-is-symbol
            symbol-is-pattern
          app-is-pattern 
                  a-is-symbol
                symbol-is-pattern 
                  c-is-symbol
                symbol-is-pattern
              app-is-pattern 
              bot-is-pattern
            imp-is-pattern 
                b-is-symbol
              symbol-is-pattern 
                c-is-symbol
              symbol-is-pattern
            app-is-pattern
          imp-is-pattern
        imp-is-pattern 
                    a-is-symbol
                  symbol-is-pattern 
                  bot-is-pattern
                imp-is-pattern 
                  b-is-symbol
                symbol-is-pattern
              imp-is-pattern 
                c-is-symbol
              symbol-is-pattern
            app-is-pattern 
                    a-is-symbol
                  symbol-is-pattern 
                    c-is-symbol
                  symbol-is-pattern
                app-is-pattern 
                bot-is-pattern
              imp-is-pattern 
                  b-is-symbol
                symbol-is-pattern 
                  c-is-symbol
                symbol-is-pattern
              app-is-pattern
            imp-is-pattern
          imp-is-pattern
        imp-reflexivity 
                _X999-is-set-var
              set-var-is-var
            var-is-pattern 
              c-is-symbol
            symbol-is-pattern
          app-is-pattern 
                  a-is-symbol
                symbol-is-pattern 
                bot-is-pattern
              imp-is-pattern 
                b-is-symbol
              symbol-is-pattern
            imp-is-pattern 
              c-is-symbol
            symbol-is-pattern
          app-is-pattern 
              a-is-symbol
            symbol-is-pattern 
              c-is-symbol
            symbol-is-pattern
          app-is-pattern 
              b-is-symbol
            symbol-is-pattern 
              c-is-symbol
            symbol-is-pattern
          app-is-pattern 
            a-is-symbol
          symbol-is-pattern 
            b-is-symbol
          symbol-is-pattern 
            _X999-is-set-var
          set-var-is-var $( xX $) 
                _X999-is-set-var
              set-var-is-var
            var-is-pattern 
              c-is-symbol
            symbol-is-pattern 
              _X999-is-set-var
            set-var-is-var 
                _X999-is-set-var
              set-var-is-var
            application-context-var
          application-context-app-left $( proof-rule-propagation-or.0 $) 
                  a-is-symbol
                symbol-is-pattern 
                bot-is-pattern
              imp-is-pattern 
                b-is-symbol
              symbol-is-pattern
            imp-is-pattern 
                  a-is-symbol
                symbol-is-pattern 
                bot-is-pattern
              imp-is-pattern 
                b-is-symbol
              symbol-is-pattern
            imp-is-pattern 
              c-is-symbol
            symbol-is-pattern 
                _X999-is-set-var
              set-var-is-var
            var-is-pattern 
              c-is-symbol
            symbol-is-pattern 
              _X999-is-set-var
            set-var-is-var 
                    a-is-symbol
                  symbol-is-pattern 
                  bot-is-pattern
                imp-is-pattern 
                  b-is-symbol
                symbol-is-pattern
              imp-is-pattern 
                _X999-is-set-var
              set-var-is-var
            substitution-var-same $( substitution-app.0 $) 
                c-is-symbol
              symbol-is-pattern 
                    a-is-symbol
                  symbol-is-pattern 
                  bot-is-pattern
                imp-is-pattern 
                  b-is-symbol
                symbol-is-pattern
              imp-is-pattern 
                _X999-is-set-var
              set-var-is-var 
                  _X999-is-set-var
                set-var-is-var 
                c-is-symbol
              fresh-in-symbol $( substitution-fresh.0 $)
            substitution-fresh $( substitution-app.1 $)
          substitution-app $( proof-rule-propagation-or.1 $) 
              a-is-symbol
            symbol-is-pattern 
              a-is-symbol
            symbol-is-pattern 
              c-is-symbol
            symbol-is-pattern 
                _X999-is-set-var
              set-var-is-var
            var-is-pattern 
              c-is-symbol
            symbol-is-pattern 
              _X999-is-set-var
            set-var-is-var 
                a-is-symbol
              symbol-is-pattern 
                _X999-is-set-var
              set-var-is-var
            substitution-var-same $( substitution-app.0 $) 
                c-is-symbol
              symbol-is-pattern 
                a-is-symbol
              symbol-is-pattern 
                _X999-is-set-var
              set-var-is-var 
                  _X999-is-set-var
                set-var-is-var 
                c-is-symbol
              fresh-in-symbol $( substitution-fresh.0 $)
            substitution-fresh $( substitution-app.1 $)
          substitution-app $( proof-rule-propagation-or.2  $) 
              b-is-symbol
            symbol-is-pattern 
              b-is-symbol
            symbol-is-pattern 
              c-is-symbol
            symbol-is-pattern 
                _X999-is-set-var
              set-var-is-var
            var-is-pattern 
              c-is-symbol
            symbol-is-pattern 
              _X999-is-set-var
            set-var-is-var 
                b-is-symbol
              symbol-is-pattern 
                _X999-is-set-var
              set-var-is-var
            substitution-var-same $( substitution-app.0 $) 
                c-is-symbol
              symbol-is-pattern 
                b-is-symbol
              symbol-is-pattern 
                _X999-is-set-var
              set-var-is-var 
                  _X999-is-set-var
                set-var-is-var 
                c-is-symbol
              fresh-in-symbol $( substitution-fresh.0 $)
            substitution-fresh $( substitution-app.1 $)
          substitution-app $( proof-rule-propagation-or.3 $)
        proof-rule-propagation-or-desugared $( proof-rule-propagation-or-desugared $)
      proof-rule-mp $( proof-rule-mp $)
    proof-rule-frame $( proof-rule-frame $)
  proof-rule-mp $( proof-rule-mp $) 
          _X999-is-set-var
        set-var-is-var
      var-is-pattern 
        c-is-symbol
      symbol-is-pattern
    app-is-pattern 
              a-is-symbol
            symbol-is-pattern 
              c-is-symbol
            symbol-is-pattern
          app-is-pattern 
          bot-is-pattern
        imp-is-pattern 
            b-is-symbol
          symbol-is-pattern 
            c-is-symbol
          symbol-is-pattern
        app-is-pattern
      imp-is-pattern 
        c-is-symbol
      symbol-is-pattern
    app-is-pattern 
          a-is-symbol
        symbol-is-pattern 
          c-is-symbol
        symbol-is-pattern
      app-is-pattern 
        c-is-symbol
      symbol-is-pattern
    app-is-pattern 
          b-is-symbol
        symbol-is-pattern 
          c-is-symbol
        symbol-is-pattern
      app-is-pattern 
        c-is-symbol
      symbol-is-pattern
    app-is-pattern 
        a-is-symbol
      symbol-is-pattern 
        c-is-symbol
      symbol-is-pattern
    app-is-pattern 
        b-is-symbol
      symbol-is-pattern 
        c-is-symbol
      symbol-is-pattern
    app-is-pattern 
      _X999-is-set-var
    set-var-is-var $( xX $) 
          _X999-is-set-var
        set-var-is-var
      var-is-pattern 
        c-is-symbol
      symbol-is-pattern 
        _X999-is-set-var
      set-var-is-var 
          _X999-is-set-var
        set-var-is-var
      application-context-var
    application-context-app-left $( proof-rule-propagation-or.0 $) 
              a-is-symbol
            symbol-is-pattern 
              c-is-symbol
            symbol-is-pattern
          app-is-pattern 
          bot-is-pattern
        imp-is-pattern 
            b-is-symbol
          symbol-is-pattern 
            c-is-symbol
          symbol-is-pattern
        app-is-pattern
      imp-is-pattern 
              a-is-symbol
            symbol-is-pattern 
              c-is-symbol
            symbol-is-pattern
          app-is-pattern 
          bot-is-pattern
        imp-is-pattern 
            b-is-symbol
          symbol-is-pattern 
            c-is-symbol
          symbol-is-pattern
        app-is-pattern
      imp-is-pattern 
        c-is-symbol
      symbol-is-pattern 
          _X999-is-set-var
        set-var-is-var
      var-is-pattern 
        c-is-symbol
      symbol-is-pattern 
        _X999-is-set-var
      set-var-is-var 
                a-is-symbol
              symbol-is-pattern 
                c-is-symbol
              symbol-is-pattern
            app-is-pattern 
            bot-is-pattern
          imp-is-pattern 
              b-is-symbol
            symbol-is-pattern 
              c-is-symbol
            symbol-is-pattern
          app-is-pattern
        imp-is-pattern 
          _X999-is-set-var
        set-var-is-var
      substitution-var-same $( substitution-app.0 $) 
          c-is-symbol
        symbol-is-pattern 
                a-is-symbol
              symbol-is-pattern 
                c-is-symbol
              symbol-is-pattern
            app-is-pattern 
            bot-is-pattern
          imp-is-pattern 
              b-is-symbol
            symbol-is-pattern 
              c-is-symbol
            symbol-is-pattern
          app-is-pattern
        imp-is-pattern 
          _X999-is-set-var
        set-var-is-var 
            _X999-is-set-var
          set-var-is-var 
          c-is-symbol
        fresh-in-symbol $( substitution-fresh.0 $)
      substitution-fresh $( substitution-app.1 $)
    substitution-app $( proof-rule-propagation-or.1 $) 
          a-is-symbol
        symbol-is-pattern 
          c-is-symbol
        symbol-is-pattern
      app-is-pattern 
          a-is-symbol
        symbol-is-pattern 
          c-is-symbol
        symbol-is-pattern
      app-is-pattern 
        c-is-symbol
      symbol-is-pattern 
          _X999-is-set-var
        set-var-is-var
      var-is-pattern 
        c-is-symbol
      symbol-is-pattern 
        _X999-is-set-var
      set-var-is-var 
            a-is-symbol
          symbol-is-pattern 
            c-is-symbol
          symbol-is-pattern
        app-is-pattern 
          _X999-is-set-var
        set-var-is-var
      substitution-var-same $( substitution-app.0 $) 
          c-is-symbol
        symbol-is-pattern 
            a-is-symbol
          symbol-is-pattern 
            c-is-symbol
          symbol-is-pattern
        app-is-pattern 
          _X999-is-set-var
        set-var-is-var 
            _X999-is-set-var
          set-var-is-var 
          c-is-symbol
        fresh-in-symbol $( substitution-fresh.0 $)
      substitution-fresh $( substitution-app.1 $)
    substitution-app $( proof-rule-propagation-or.2  $) 
          b-is-symbol
        symbol-is-pattern 
          c-is-symbol
        symbol-is-pattern
      app-is-pattern 
          b-is-symbol
        symbol-is-pattern 
          c-is-symbol
        symbol-is-pattern
      app-is-pattern 
        c-is-symbol
      symbol-is-pattern 
          _X999-is-set-var
        set-var-is-var
      var-is-pattern 
        c-is-symbol
      symbol-is-pattern 
        _X999-is-set-var
      set-var-is-var 
            b-is-symbol
          symbol-is-pattern 
            c-is-symbol
          symbol-is-pattern
        app-is-pattern 
          _X999-is-set-var
        set-var-is-var
      substitution-var-same $( substitution-app.0 $) 
          c-is-symbol
        symbol-is-pattern 
            b-is-symbol
          symbol-is-pattern 
            c-is-symbol
          symbol-is-pattern
        app-is-pattern 
          _X999-is-set-var
        set-var-is-var 
            _X999-is-set-var
          set-var-is-var 
          c-is-symbol
        fresh-in-symbol $( substitution-fresh.0 $)
      substitution-fresh $( substitution-app.1 $)
    substitution-app $( proof-rule-propagation-or.3 $)
  proof-rule-propagation-or-desugared $( proof-rule-propagation-or-desugared $)
proof-rule-mp $( proof-rule-mp $) $. 
